﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     GuiLabel.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_COMMON_SCENE_GUILABEL_H_
#define NN_COMMON_SCENE_GUILABEL_H_

#include "GuiControlBase.h"

namespace scene
{
    /* Please see man pages for details 
        
    */
    class Label : public ControlBase
    {
    public:
        /* Please see man pages for details 
            

            
            
            
            
            
            
            
        */
        Label(u32 id, s32 x, s32 y, u32 width, u32 height, const wchar_t* pText = NULL, void* pExtraData = NULL, f32 fontScale = DEFAULT_FONT_SCALE);

        /* Please see man pages for details 
            
        */
        virtual ~Label();

    protected:
        // Processing when pressed with the stylus
        virtual void OnPenDown();
        // Processing when the stylus is lifted
        virtual void OnPenUp(bool isIn);
        // Processing when sliding with the stylus
        virtual void OnPenSlide(bool isIn);
        // Processing when tapped with the stylus
        virtual void OnPenTouch();
        // Processing during rendering
        virtual void OnDraw();
    };
}

#endif // NN_COMMON_SCENE_GUILABEL_H_
