﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     GuiTypes.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_COMMON_SCENE_GUITYPES_H_
#define NN_COMMON_SCENE_GUITYPES_H_

#include <nn/types.h>

namespace scene
{
    /* Please see man pages for details 
        
    */
    static const u32 CONTROL_ID_UNUSED = 0xFFFFFFFF;

    /* Please see man pages for details 
        
    */
    enum ControlType
    {
        CONTROL_TYPE_LABEL,  //
        CONTROL_TYPE_BUTTON, //

        CONTROL_TYPE_MAX
    };

    /* Please see man pages for details 
        
    */
    enum ControlState
    {
        CONTROL_STATE_DEFAULT,   //
        CONTROL_STATE_DISABLED,  //
        CONTROL_STATE_SELECTING, //
        CONTROL_STATE_HIDE,      //

        CONTROL_STATE_MAX
    };

    /* Please see man pages for details 
        
    */
    enum ControlEvent
    {
        CONTROL_EVENT_PENDOWN,      //
        CONTROL_EVENT_PENUP,        //
        CONTROL_EVENT_SLIDE,        //
        CONTROL_EVENT_TOUCH,        //
        CONTROL_EVENT_CHANGE_STATE, //

        CONTROL_EVENT_MAX
    };

    /* Please see man pages for details 
        
    */
    enum TextAlign
    {
        TEXT_ALIGN_LEFT,   //
        TEXT_ALIGN_RIGHT,  //
        TEXT_ALIGN_CENTER, //

        TEXT_ALIGN_MAX
    };

    //
    const f32 DEFAULT_FONT_SCALE = 0.6f;
}

#endif // NN_COMMON_SCENE_GUITYPES_H_
