/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     acc.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/os.h>
#include <nn/hid.h>
#include "acc.h"

void AccDemo::DrawFrame(void)
{    
    mp_RenderSystem->SetColor(1.0f, 1.0f, 1.0f, 1.0f);

    // Gets most recent accelerometer data
    nn::hid::AccelerometerStatus accStatus;
    m_AccReader.ReadLatest(&accStatus);
    // Converts accelerometer value units to "G"
    nn::hid::AccelerationFloat accFloat;
    m_AccReader.ConvertToAcceleration(&accFloat, 1, &accStatus);
 
    mp_RenderSystem->DrawText(0, 200, "Gx : % .2lf", accFloat.x);
    mp_RenderSystem->DrawText(0, 210, "Gy : % .2lf", accFloat.y);
    mp_RenderSystem->DrawText(0, 220, "Gz : % .2lf", accFloat.z);
}

nn::hid::AccelerometerStatus AccDemo::GetLatestAccStatus(void)
{
    // Gets most recent accelerometer data
    nn::hid::AccelerometerStatus accStatus;
    m_AccReader.ReadLatest(&accStatus);

    return accStatus;
}

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
