﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     kbd.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLE_DEMOS_DEMO1_KBD_H_
#define NN_SAMPLE_DEMOS_DEMO1_KBD_H_

#include "device.h"

static const s32 KEYBOARD_BUFFER_SIZE = 4 * 1024 * 128;

class SwkbdDemo : public Device
{
public:
    virtual void Initialize(demo::RenderSystemDrawing* p_RenderSystem);
    virtual void DrawFrame(void);

    bool Exec(void);

private:
    demo::RenderSystemDrawing*      mp_RenderSystem;
    nn::swkbd::Parameter            m_Param;
    s32                             m_Size;
    wchar_t                         m_TextBuffer[10];
    nn::applet::AppletWakeupState   m_WakeupState;
    NN_PADDING3;

    static u8                       m_KeyboardBuffer[KEYBOARD_BUFFER_SIZE];
};

/* NN_SAMPLE_DEMOS_DEMO1_KBD_H_ */
#endif

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
