﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     savedata.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLE_DEMOS_DEMO1_SAVEDATA_H_
#define NN_SAMPLE_DEMOS_DEMO1_SAVEDATA_H_

#include "device.h"
#include <nn/os.h>

class SaveDataDemo : public Device
{
public:
    virtual void Initialize(demo::RenderSystemDrawing* p_RenderSystem) { Device::Initialize(p_RenderSystem); }
    void Initialize(demo::RenderSystemDrawing* p_RenderSystem, nn::fnd::ExpHeap* p_AppHeap);
    virtual void Finalize(void);

    virtual void Start(void);
    virtual void End(void);

private:
    virtual void DrawFrame(void);

    void ThreadFuncImpl();
    static void ThreadFunc(SaveDataDemo* saveDataDemo);

    static const size_t SAVEDATA_SIZE = 128;
    static const char*  SAVEDATA_FILENAME;
    static const char*  SAVEDATA_ARCHIVE;
    char m_WriteFileBuffer[SAVEDATA_SIZE];
    char m_ReadFileBuffer[SAVEDATA_SIZE];
    char m_SaveDataBuffer[SAVEDATA_SIZE];

    NN_PADDING4;

    nn::fs::FileStream m_SaveDataFile;

    bool m_IsAvailable;
    bool m_IsFormatted;
    bool m_IsMounted;
    NN_PADDING1;

    nn::os::Thread m_Thread;
    nn::os::StackBuffer<1024>   m_Stack;

    nn::os::LightEvent m_ExitEvent;
};

/* NN_SAMPLE_DEMOS_DEMO1_SAVEDATA_H_ */
#endif

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
