/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     dlpDemo.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev:$
 *---------------------------------------------------------------------------*/

#ifndef NN_DLPDEMO_H_
#define NN_DLPDEMO_H_

const u8        MAX_CLIENT              = 15;

const u8        SCAN_NUM                 = 16;

// Font size
const u32       FONT_SIZE                =  8;

// Line width
const f32       LINE_WIDTH               =  1.f;

const char      PATHPRHRASE[]             = "CTR_SDK_SAMPLE";
const u8        SUB_ID                    = 0x01;
const bit32     UNIQUE_ID_SAMPLEDEMOS_DLP = 0x000FFF00;


// Render color definition
#define WHITE_COLOR     1.f, 1.f, 1.f
#define GRAY_COLOR      0.5, 0.5, 0.5
#define RED_COLOR       1.f, 0.f, 0.f
#define GREEN_COLOR     0.f, 1.f, 0.f
#define BLUE_COLOR      0.f, 0.f, 1.f

#define DLP_DEBUG_POINT                 NN_LOG("l.%d:%s > \n", __LINE__, __func__)
#define DLP_DEBUG_PRINT( ... )          NN_LOG("l.%d:%s > ", __LINE__, __func__);NN_LOG(__VA_ARGS__)
#define DLP_DEBUG_PRINT_SIMPLE( ... )   NN_LOG(__VA_ARGS__)
#define DLP_ROUNDUP(x, base)            (((x) + ((base)-1)) & ~((base)-1))

/* NN_DLPDEMO_H_ */
#endif

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
