﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     FsSample.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 47228 $
 *---------------------------------------------------------------------------*/

#include "FsSample.h"
#include <nn/os.h>
#include <nn/fnd.h>


namespace
{
    // This sample allocates memory from the expanded heap
    nn::fnd::ExpHeap s_ExtHeap;
}


void FsSampleInitialize()
{
    // fs initialization
    nn::fs::Initialize();

    // Initialize the heap
    s_ExtHeap.Initialize(nn::os::GetDeviceMemoryAddress(), nn::os::GetDeviceMemorySize() );
}

void FsSampleFinalize()
{
    // Heap cleanup
    s_ExtHeap.Finalize();
}

void* FsSampleAllocateMemory(size_t size)
{
    return s_ExtHeap.Allocate(size);
}

void FsSampleFreeMemory(void* p)
{
    s_ExtHeap.Free(p);
}

