﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     FsSample.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLEDEMOS_FS_FSSAMPLE_H_
#define NN_SAMPLEDEMOS_FS_FSSAMPLE_H_

#include <nn.h>
#include <nn/fs.h>
#include <nn/err.h>


// Creates application-specific OutOfMemory error
NN_DEFINE_RESULT_CONST( \
    ResultAppOutOfMemory, \
    nn::Result::LEVEL_PERMANENT, nn::Result::SUMMARY_OUT_OF_RESOURCE, nn::Result::MODULE_APPLICATION, nn::Result::DESCRIPTION_OUT_OF_MEMORY);

void    FsSampleInitialize();
void    FsSampleFinalize();

void*   FsSampleAllocateMemory(size_t size);
void    FsSampleFreeMemory(void* p);


#endif // NN_SAMPLEDEMOS_FS_FSSAMPLE_H_

