﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     main.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/applet.h>

#include "FsSample.h"
#include "FsSampleArchive.h"
#include "FsSampleFile.h"


extern "C" void nnMain( void )
{
    // Call only the nn::applet::Enable function to also allow execution from the HOME Menu
    // HOME Menu transitions, POWER Button presses, and sleep are all unsupported
    nn::applet::Enable();

    NN_LOG("=== fs sample demo start ===\n");

    FsSampleInitialize();

    FsSampleCheckSaveData();

    if(FsSampleMountRom())
    {
        FsSampleReadRomFile();
    }

    if(FsSampleMountSaveData())
    {
        FsSampleCreateSaveDataFile();
        FsSampleReadSaveDataFile();
    }

    if(FsSampleMountExtSaveData())
    {
        FsSampleCreateExtSaveDataFile();
        FsSampleReadExtSaveDataFile();
    }

    if(FsSampleMountSdmcWriteOnly())
    {
        FsSampleCreateSdmcWriteOnlyFile();
    }

    FsSampleUnmountRom();
    FsSampleUnmountSaveData();
    FsSampleUnmountExtSaveData();
    FsSampleUnmountSdmcWriteOnly();
    FsSampleFinalize();

    NN_LOG("=== fs sample demo end ===\n");
}
