﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     Object.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef _EARLYDEPTHTESTSAMPLE_OBJECT_H_
#define _EARLYDEPTHTESTSAMPLE_OBJECT_H_

//Cube
static f32 s_CubePos[] = 
{
    -1.0f,-1.0f, 1.0f,   1.0f, 1.0f, 1.0f,  -1.0f, 1.0f, 1.0f,  1.0f,-1.0f, 1.0f,       // front
    -1.0f,-1.0f,-1.0f,   1.0f, 1.0f,-1.0f,  -1.0f, 1.0f,-1.0f,  1.0f,-1.0f,-1.0f,       // back
     1.0f,-1.0f,-1.0f,   1.0f, 1.0f, 1.0f,   1.0f,-1.0f, 1.0f,  1.0f, 1.0f,-1.0f,       // right
    -1.0f,-1.0f,-1.0f,  -1.0f, 1.0f, 1.0f,  -1.0f,-1.0f, 1.0f,  -1.0f,1.0f,-1.0f,       // left
    -1.0f,-1.0f,-1.0f,   1.0f,-1.0f, 1.0f,  -1.0f,-1.0f, 1.0f,  1.0f,-1.0f,-1.0f,       // bottom
    -1.0f, 1.0f,-1.0f,   1.0f, 1.0f, 1.0f,  -1.0f, 1.0f, 1.0f,  1.0f, 1.0f,-1.0f        // top
};

static f32 s_CubeNormal[] = 
{
    0.f, 0.f, 1.f,  0.f, 0.f, 1.f,  0.f, 0.f, 1.f,  0.f, 0.f, 1.f,
    0.f, 0.f,-1.f,  0.f, 0.f,-1.f,  0.f, 0.f,-1.f,  0.f, 0.f,-1.f,
    1.f, 0.f, 0.f,  1.f, 0.f, 0.f,  1.f, 0.f, 0.f,  1.f, 0.f, 0.f, 
    -1.f,0.f, 0.f, -1.f, 0.f, 0.f, -1.f, 0.f, 0.f, -1.f, 0.f, 0.f, 
    0.f,-1.f, 0.f,  0.f,-1.f, 0.f,  0.f,-1.f, 0.f,  0.f,-1.f, 0.f, 
    0.f, 1.f, 0.f,  0.f, 1.f, 0.f,  0.f, 1.f, 0.f,  0.f, 1.f, 0.f
};

static f32 s_CubeTexCoord[] = 
{
    1.0f, 0.0f, 0.0f,  0.0f, 1.0f, 0.0f,  0.0f, 0.0f, 0.0f,  1.0f, 1.0f, 0.0f,        // front
    1.0f, 0.0f, 0.0f,  0.0f, 1.0f, 0.0f,  0.0f, 0.0f, 0.0f,  1.0f, 1.0f, 0.0f,        // back
    1.0f, 0.0f, 0.0f,  0.0f, 1.0f, 0.0f,  0.0f, 0.0f, 0.0f,  1.0f, 1.0f, 0.0f,        // right
    1.0f, 0.0f, 0.0f,  0.0f, 1.0f, 0.0f,  0.0f, 0.0f, 0.0f,  1.0f, 1.0f, 0.0f,        // left
    1.0f, 0.0f, 0.0f,  0.0f, 1.0f, 0.0f,  0.0f, 0.0f, 0.0f,  1.0f, 1.0f, 0.0f,        // bottom
    1.0f, 0.0f, 0.0f,  0.0f, 1.0f, 0.0f,  0.0f, 0.0f, 0.0f,  1.0f, 1.0f, 0.0f,        // top
};

static u16 s_CubeIdx[] = 
{
    0,1,2, 0,3,1,
    4,6,5, 4,5,7,
    8,9,10, 8,11,9,
    12,14,13, 12,13,15,
    16,17,18, 16,19,17,
    20,22,21, 20,21,23
};

#endif
