//
//------------------------------------------------------------
// Copyright(c) 2009-2010 by Digital Media Professionals Inc.
// All rights reserved.
//------------------------------------------------------------
// This source code is the confidential and proprietary
// of Digital Media Professionals Inc.
//------------------------------------------------------------
//

// Input registers map
#define aPosition       v0
#define aTexCoord       v1
#define aColor          v2

// Output registers map
#define vPosition       o0
#define vTexCoord       o1
#define vColor          o2

#define CONST               c95     // 0.0 0.5 1.0 3.0

// Constant registers
def     CONST,              0.0, 0.5, 1.0, 3.0

#pragma bind_symbol( aPosition.xyz, v0, v0)
#pragma bind_symbol( aTexCoord.xy,  v1, v1)
#pragma bind_symbol( aColor,        v2, v2)

#pragma output_map ( position, o0 )
#pragma output_map ( texture0, o1 )
#pragma output_map ( color,    o2 )

main:
    mov     vPosition.xyz,      aPosition.xyz
    mov     vPosition.w,        CONST.z
    mov     vColor,         aColor
    mov     vTexCoord,      aTexCoord
    end
endmain:
