﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     gx_ScreenCapture.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn.h>
#include <nn/os.h>
#include <nn/fnd.h>
#include <nn/gx.h>
#include <nn/math.h>
#include <nn/fs.h>
#include <nn/init.h>
#include <nn/applet.h>

extern void Initialize(void);
extern void Finalize(void);
extern bool DrawFrame(bool isCapture);

bool PadReadAndEvent(nn::hid::PadReader& padReader)
{
    nn::hid::PadStatus pad;
    padReader.ReadLatest(&pad);
    
    if (pad.trigger & nn::hid::BUTTON_A)
    {
        return true;
    }
    
    return false;
}

void nnMain(void)
{
    // Call only nn::applet::Enable to also allow execution from the HOME Menu
    // HOME Menu transitions, POWER Button presses, and sleep are all unsupported
    nn::applet::Enable();

    Initialize();
    
    nn::hid::PadReader padReader;
    bool flag = true;
    while ( flag )
    {
        flag = DrawFrame(PadReadAndEvent(padReader));
    }

    Finalize();
}
