﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     gdApplicationSample.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/gx.h>
#include <nn/fs.h>
#include <nn/math.h>
#include <nn/init.h>
#include <nn/os.h>
#include "demo.h"
#include <math.h>
#include "Tga.h"

#include "../../../gx/DMPGL/Common/Util.h"
#include "../../../gx/DMPGL/Common/Loader.h"
#include "../../../gx/DMPGL/Common/Memory.h"

#include <string.h>
#include <nn/gd.h>

typedef struct tag_datGD_t
{
    nn::gd::VertexBufferResource*          posVB;
    nn::gd::VertexBufferResource*          normVB;
    nn::gd::VertexBufferResource*          texVB;
    nn::gd::VertexBufferResource*          tangVB;
    nn::gd::VertexBufferResource*          wghtVB;
    nn::gd::VertexBufferResource*          midxVB;
    nn::gd::VertexBufferResource*          idxVB;
    dat_obj_t*      obj;
    dat_patch_t*    patch;
    int             obj_num;
} datGD_t;

void loadDAT_GD(const char* _name, datGD_t* _dat);
void unloadDAT_GD(datGD_t* dat);

/* lighting Initialization */
int LightInitialize();

/* lighting Finitialization */
void LightFinalize();

/* Lighting Drawing */
void DrawLights();

/* PartsysSimple Initialization */
int PartsysSimpleInitialize();

/*  PartsysSimple Finitialization */
void PartsysSimpleFinalize();

/* PartsysSimple Drawing */
int DrawPartsysSimple();

/* PartsysGas Initialization */
void PartsysGasInitialize();

/*  PartsysGas Finitialization */
void PartsysGasFinalize();

/* PartsysGas Drawing */
int DrawPartsysGas(void);
