﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     PartsysPattern.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

enum PARTSYS_PATTERN
{
    PARTSYS_DEFAULT = 0x0,
    PARTSYS_EXPLOSION1,
    PARTSYS_EXPLOSION2,
    PARTSYS_SNOW,
    PARTSYS_SPIN,
    PARTSYS_LAST
};

/**********************************************************************************************************/
/********************Basic particle pattern****************************************************************/
/**********************************************************************************************************/
static void LoadParticleSystem1(struct _particleSys *pp)
{
    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point positions---------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_center.m[0][0] = 0.0f;      /*|*/   pp->m_partsys_center.m[1][0] = -10.0f;
    pp->m_partsys_center.m[0][1] = -10.0f;    /*|*/   pp->m_partsys_center.m[1][1] = -5.0f;
    pp->m_partsys_center.m[0][2] = 0.0f;      /*|*/   pp->m_partsys_center.m[1][2] = 0.0f;
    pp->m_partsys_center.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_center.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_center.m[2][0] = 10.0f;     /*|*/   pp->m_partsys_center.m[3][0] = 0.0f;
    pp->m_partsys_center.m[2][1] = 5.0f;      /*|*/   pp->m_partsys_center.m[3][1] = 10.0f;
    pp->m_partsys_center.m[2][2] = 0.0f;      /*|*/   pp->m_partsys_center.m[3][2] = 0.0f;
    pp->m_partsys_center.m[2][3] = 1.0f;      /*|*/   pp->m_partsys_center.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point colors------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_color.m[0][0] = 0.0f;       /*|*/   pp->m_partsys_color.m[1][0] = 1.0f;
    pp->m_partsys_color.m[0][1] = 0.0f;       /*|*/   pp->m_partsys_color.m[1][1] = 0.0f;
    pp->m_partsys_color.m[0][2] = 0.0f;       /*|*/   pp->m_partsys_color.m[1][2] = 0.0f;
    pp->m_partsys_color.m[0][3] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_color.m[2][0] = 0.0f;       /*|*/   pp->m_partsys_color.m[3][0] = 0.0f;
    pp->m_partsys_color.m[2][1] = 1.0f;       /*|*/   pp->m_partsys_color.m[3][1] = 0.0f;
    pp->m_partsys_color.m[2][2] = 0.0f;       /*|*/   pp->m_partsys_color.m[3][2] = 1.0f;
    pp->m_partsys_color.m[2][3] = 0.5f;       /*|*/   pp->m_partsys_color.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 bounding boxes------------------------------------------*/
    /*--------Radii in X, Y and Z direction. W not used ----------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_radius.m[0][0] = 0.0f;      /*|*/   pp->m_partsys_radius.m[1][0] = 1.0f;
    pp->m_partsys_radius.m[0][1] = 0.0f;      /*|*/   pp->m_partsys_radius.m[1][1] = 1.0f;
    pp->m_partsys_radius.m[0][2] = 0.0f;      /*|*/   pp->m_partsys_radius.m[1][2] = 1.0f;
    pp->m_partsys_radius.m[0][3] = 0.0f;      /*|*/   pp->m_partsys_radius.m[1][3] = 0.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_radius.m[2][0] = 1.0f;      /*|*/   pp->m_partsys_radius.m[3][0] = 10.0f;
    pp->m_partsys_radius.m[2][1] = 1.0f;      /*|*/   pp->m_partsys_radius.m[3][1] = 1.0f;
    pp->m_partsys_radius.m[2][2] = 1.0f;      /*|*/   pp->m_partsys_radius.m[3][2] = 1.0f;
    pp->m_partsys_radius.m[2][3] = 1.0f;      /*|*/   pp->m_partsys_radius.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the particle aspect-------------------------------------------*/
    /*--------Particle size, texture coordinates !!!??TBD   ------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*Rotation disabled: Size, unused,unused,unused/alpha                                 */
    /*Rotation Enabled:  Size, Angle, Radius, unused/alpha                                */
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_aspect.m[0][0] = 10.0f;     /*|*/   pp->m_partsys_aspect.m[1][0] = 30.0f;
    pp->m_partsys_aspect.m[0][1] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[1][1] = 0.0f;
    pp->m_partsys_aspect.m[0][2] = 0.9f;      /*|*/   pp->m_partsys_aspect.m[1][2] = 0.9f;
    pp->m_partsys_aspect.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_aspect.m[2][0] = 30.0f;     /*|*/   pp->m_partsys_aspect.m[3][0] = 10.0f;
    pp->m_partsys_aspect.m[2][1] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[3][1] = 0.0f;
    pp->m_partsys_aspect.m[2][2] = 0.9f;      /*|*/   pp->m_partsys_aspect.m[3][2] = 0.9f;
    pp->m_partsys_aspect.m[2][3] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    pp->m_size_min_max[0] = 1.0f;
    pp->m_size_min_max[1] = static_cast<f32>(nn::gx::DISPLAY0_HEIGHT) / 2.0f;

    pp->m_random_seed[0] = 45.0f;
    pp->m_random_seed[1] = 82.564f + pp->m_random_seed[0];
    pp->m_random_seed[2] = 18.15f + pp->m_random_seed[0];
    pp->m_random_seed[3] = 819.9875f + pp->m_random_seed[0];

    /* Core value for random
     Algorithm is based Pseudo-random number generators: X(n+1) = (a*Xn+b) mod m
     Expected values for uniform are
     [0] = a, [1] = b, [2] = m, [3] = 1/m
    */
    pp->m_prng[0] = 17.0f;                              /* a */
    pp->m_prng[1] = 37.0f;                              /* b */
    pp->m_prng[2] = 65535.0f;                           /* m */
    pp->m_prng[3] = 1.0f / (pp->m_prng[2]);             /* 1/m */

    pp->m_speed = 1.0f;             /*  emitter->particle_speed  */
    pp->m_particleCountMax = 20.0f; /*  particle number          */

    /* Application only */
    pp->simulationTime = 2.0f;
    pp->NFrame = 256;
    pp->dTime = pp->simulationTime/pp->NFrame;
}

/************************************************************************************************************/
/*********************Explosition like     ******************************************************************/
/************************************************************************************************************/
/* all the control are in (0,0,0)
 Bounding boxes have different radii 
 this gives the effect of grow/shrink for the particles
*/
static void LoadParticleSystemExplositon1(struct _particleSys *pp)
{
    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point positions---------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_center.m[0][0] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][0] = 0.0f;
    pp->m_partsys_center.m[0][1] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][1] = 0.0f;
    pp->m_partsys_center.m[0][2] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][2] = 0.0f;
    pp->m_partsys_center.m[0][3] = 1.0f;  /*|*/   pp->m_partsys_center.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_center.m[2][0] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][0] = 0.0f;
    pp->m_partsys_center.m[2][1] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][1] = 0.0f;
    pp->m_partsys_center.m[2][2] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][2] = 0.0f;
    pp->m_partsys_center.m[2][3] = 1.0f;  /*|*/   pp->m_partsys_center.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point colors------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_color.m[0][0] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][0] = 1.0f;
    pp->m_partsys_color.m[0][1] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][1] = 0.0f;
    pp->m_partsys_color.m[0][2] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][2] = 0.0f;
    pp->m_partsys_color.m[0][3] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_color.m[2][0] = 0.0f;       /*|*/   pp->m_partsys_color.m[3][0] = 0.0f;
    pp->m_partsys_color.m[2][1] = 1.0f;       /*|*/   pp->m_partsys_color.m[3][1] = 0.0f;
    pp->m_partsys_color.m[2][2] = 0.0f;       /*|*/   pp->m_partsys_color.m[3][2] = 1.0f;
    pp->m_partsys_color.m[2][3] = 1.0f;       /*|*/   pp->m_partsys_color.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 bounding boxes------------------------------------------*/
    /*--------Radii in X, Y and Z direction. W not used ----------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_radius.m[0][0] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][0] = 10.0f;
    pp->m_partsys_radius.m[0][1] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][1] = 10.0f;
    pp->m_partsys_radius.m[0][2] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][2] = 10.0f;
    pp->m_partsys_radius.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_radius.m[2][0] = 20.0f;     /*|*/   pp->m_partsys_radius.m[3][0] = 50.0f;
    pp->m_partsys_radius.m[2][1] = 20.0f;     /*|*/   pp->m_partsys_radius.m[3][1] = 50.0f;
    pp->m_partsys_radius.m[2][2] = 20.0f;     /*|*/   pp->m_partsys_radius.m[3][2] = 50.0f;
    pp->m_partsys_radius.m[2][3] = 1.0f;      /*|*/   pp->m_partsys_radius.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the particle aspect-------------------------------------------*/
    /*--------Particle size, texture coordinates !!!??TBD   ------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*Rotation disabled: Size, unused,unused,unused/alpha                                 */
    /*Rotation Enabled:  Size, Angle, Radius, unused/alpha                                */
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_aspect.m[0][0] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][0] = 2.0f;
    pp->m_partsys_aspect.m[0][1] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[1][1] = 0.0f;
    pp->m_partsys_aspect.m[0][2] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][2] = 1.0f;
    pp->m_partsys_aspect.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_aspect.m[2][0] = 30.0f;     /*|*/   pp->m_partsys_aspect.m[3][0] = 50.0f;
    pp->m_partsys_aspect.m[2][1] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[3][1] = 0.0f;
    pp->m_partsys_aspect.m[2][2] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[3][2] = 1.0f;
    pp->m_partsys_aspect.m[2][3] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    pp->m_size_min_max[0] = 1.0f;
    pp->m_size_min_max[1] = static_cast<f32>(nn::gx::DISPLAY0_HEIGHT) / 2.0f;

    pp->m_random_seed[0] = 15.8794f;
    pp->m_random_seed[1] = 2.564f + pp->m_random_seed[0];
    pp->m_random_seed[2] = 1.15f + pp->m_random_seed[0];
    pp->m_random_seed[3] = 0.9875f + pp->m_random_seed[0];

    /* Core value for random
     Algorithm is based Pseudo-random number generators: X(n+1) = (a*Xn+b) mod m
     Expected values for uniform are
     [0] = a, [1] = b, [2] = m, [3] = 1/m
    */
    pp->m_prng[0] = 147.0f;                     /* a */
    pp->m_prng[1] = 17.0f;                      /* b */
    pp->m_prng[2] = 256847.0f;                  /* m */
    pp->m_prng[3] = 1.0f / (pp->m_prng[2]);     /* 1/m */

    pp->m_speed = 0.55f;                /*  emitter->particle_speed  */
    pp->m_particleCountMax = 100.0f;    /*  particle number          */

    /* Application only */
    pp->simulationTime = 10.0f;
    pp->NFrame = 512;
    pp->dTime = pp->simulationTime/pp->NFrame;
}

/***********************************************************************************************************/
/********************Explosition like     ******************************************************************/
/***********************************************************************************************************/
/* all the control are in (0,0,0)
 Bounding boxes have growing radii 
 this gives the expanding for the particles */
static void LoadParticleSystemExplositon2(struct _particleSys *pp)
{
    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point positions---------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_center.m[0][0] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][0] = 0.0f;
    pp->m_partsys_center.m[0][1] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][1] = 0.0f;
    pp->m_partsys_center.m[0][2] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][2] = 0.0f;
    pp->m_partsys_center.m[0][3] = 1.0f;  /*|*/   pp->m_partsys_center.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_center.m[2][0] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][0] = 0.0f;
    pp->m_partsys_center.m[2][1] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][1] = 0.0f;
    pp->m_partsys_center.m[2][2] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][2] = 0.0f;
    pp->m_partsys_center.m[2][3] = 1.0f;  /*|*/   pp->m_partsys_center.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point colors------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_color.m[0][0] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][0] = 1.0f;
    pp->m_partsys_color.m[0][1] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][1] = 0.0f;
    pp->m_partsys_color.m[0][2] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][2] = 0.0f;
    pp->m_partsys_color.m[0][3] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_color.m[2][0] = 0.0f;       /*|*/   pp->m_partsys_color.m[3][0] = 0.0f;
    pp->m_partsys_color.m[2][1] = 1.0f;       /*|*/   pp->m_partsys_color.m[3][1] = 0.0f;
    pp->m_partsys_color.m[2][2] = 0.0f;       /*|*/   pp->m_partsys_color.m[3][2] = 1.0f;
    pp->m_partsys_color.m[2][3] = 1.0f;       /*|*/   pp->m_partsys_color.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 bounding boxes------------------------------------------*/
    /*--------Radii in X, Y and Z direction. W not used ----------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_radius.m[0][0] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][0] = 1.0f;
    pp->m_partsys_radius.m[0][1] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][1] = 1.0f;
    pp->m_partsys_radius.m[0][2] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][2] = 1.0f;
    pp->m_partsys_radius.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_radius.m[2][0] = 80.0f;     /*|*/   pp->m_partsys_radius.m[3][0] = 0.0f;
    pp->m_partsys_radius.m[2][1] = 80.0f;     /*|*/   pp->m_partsys_radius.m[3][1] = 0.0f;
    pp->m_partsys_radius.m[2][2] = 80.0f;     /*|*/   pp->m_partsys_radius.m[3][2] = 0.0f;
    pp->m_partsys_radius.m[2][3] = 1.0f;      /*|*/   pp->m_partsys_radius.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the particle aspect-------------------------------------------*/
    /*--------Particle size, texture coordinates !!!??TBD   ------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*Rotation disabled: Size, unused,unused,unused/alpha                                 */
    /*Rotation Enabled:  Size, Angle, Radius, unused/alpha                                */
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_aspect.m[0][0] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[1][0] = 3.0f;
    pp->m_partsys_aspect.m[0][1] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[1][1] = 3.0f;
    pp->m_partsys_aspect.m[0][2] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][2] = 1.0f;
    pp->m_partsys_aspect.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_aspect.m[2][0] = 20.0f;     /*|*/   pp->m_partsys_aspect.m[3][0] = 0.0f;
    pp->m_partsys_aspect.m[2][1] = -3.0f;     /*|*/   pp->m_partsys_aspect.m[3][1] = -6.0f;
    pp->m_partsys_aspect.m[2][2] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[3][2] = 1.0f;
    pp->m_partsys_aspect.m[2][3] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    pp->m_size_min_max[0] = 1.0f;
    pp->m_size_min_max[1] = static_cast<f32>(nn::gx::DISPLAY0_HEIGHT) / 2.0f;

    pp->m_random_seed[0] = 735.0f;
    pp->m_random_seed[1] = 2.564f + pp->m_random_seed[0];
    pp->m_random_seed[2] = 1.15f + pp->m_random_seed[0];
    pp->m_random_seed[3] = 0.9875f + pp->m_random_seed[0];

    /* Core value for random
     Algorithm is based Pseudo-random number generators: X(n+1) = (a*Xn+b) mod m
     Expected values for uniform are
     [0] = a, [1] = b, [2] = m, [3] = 1/m
    */
    pp->m_prng[0] = 147.0f;                 /* a */
    pp->m_prng[1] = 17.0f;                  /* b */
    pp->m_prng[2] = 256847.0f;              /* m */
    pp->m_prng[3] = 1.0f / (pp->m_prng[2]); /* 1/m */

    pp->m_speed = 0.55f;                /*  emitter->particle_speed  */
    pp->m_particleCountMax = 100.0f;    /*  particle number          */

    /* Application only */
    pp->simulationTime = 10.0f;
    pp->NFrame = 512;
    pp->dTime = pp->simulationTime/pp->NFrame;
}
/*********************************************************************************************************/
/********************Snow / Falling flocon ***************************************************************/
/*********************************************************************************************************/
/* all the control are in (0,0,0)
 Falling particles */
static void LoadParticleSystemSnow(struct _particleSys *pp)
{
    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point positions---------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_center.m[0][0] = 25.0f;  /*|*/   pp->m_partsys_center.m[1][0] = 20.0f;
    pp->m_partsys_center.m[0][1] = -30.0f; /*|*/   pp->m_partsys_center.m[1][1] = -20.0f;
    pp->m_partsys_center.m[0][2] = 30.0f;  /*|*/   pp->m_partsys_center.m[1][2] = 30.0f;
    pp->m_partsys_center.m[0][3] = 1.0f;  /*|*/   pp->m_partsys_center.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_center.m[2][0] = -10.0f;  /*|*/   pp->m_partsys_center.m[3][0] = -30.0f;
    pp->m_partsys_center.m[2][1] = 20.0f; /*|*/   pp->m_partsys_center.m[3][1] = 30.0f;
    pp->m_partsys_center.m[2][2] = -30.0f;  /*|*/   pp->m_partsys_center.m[3][2] = -30.0f;
    pp->m_partsys_center.m[2][3] = 1.0f;  /*|*/   pp->m_partsys_center.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point colors------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_color.m[0][0] = 1.f;       /*|*/   pp->m_partsys_color.m[1][0] = 1.f;
    pp->m_partsys_color.m[0][1] = 1.f;       /*|*/   pp->m_partsys_color.m[1][1] = 1.f;
    pp->m_partsys_color.m[0][2] = 1.f;       /*|*/   pp->m_partsys_color.m[1][2] = 1.f;
    pp->m_partsys_color.m[0][3] = 1.f;       /*|*/   pp->m_partsys_color.m[1][3] = 1.f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_color.m[2][0] = 1.f;       /*|*/   pp->m_partsys_color.m[3][0] = 1.f;
    pp->m_partsys_color.m[2][1] = 1.f;       /*|*/   pp->m_partsys_color.m[3][1] = 1.f;
    pp->m_partsys_color.m[2][2] = 1.f;       /*|*/   pp->m_partsys_color.m[3][2] = 1.f;
    pp->m_partsys_color.m[2][3] = 1.0f;       /*|*/   pp->m_partsys_color.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 bounding boxes------------------------------------------*/
    /*--------Radii in X, Y and Z direction. W not used ----------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_radius.m[0][0] = 150.0f;    /*|*/   pp->m_partsys_radius.m[1][0] = 150.0f;
    pp->m_partsys_radius.m[0][1] = 50.0f;      /*|*/   pp->m_partsys_radius.m[1][1] = 50.0f;
    pp->m_partsys_radius.m[0][2] = 10.0f;      /*|*/   pp->m_partsys_radius.m[1][2] = 10.0f;
    pp->m_partsys_radius.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_radius.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_radius.m[2][0] = 150.0f;    /*|*/   pp->m_partsys_radius.m[3][0] = 150.0f;
    pp->m_partsys_radius.m[2][1] = 50.0f;     /*|*/   pp->m_partsys_radius.m[3][1] = 50.0f;
    pp->m_partsys_radius.m[2][2] = 10.0f;     /*|*/   pp->m_partsys_radius.m[3][2] = 10.0f;
    pp->m_partsys_radius.m[2][3] = 1.0f;      /*|*/   pp->m_partsys_radius.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the particle aspect-------------------------------------------*/
    /*--------Particle size, texture coordinates !!!??TBD   ------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*Rotation disabled: Size, unused,unused,unused/alpha                                 */
    /*Rotation Enabled:  Size, Angle, Radius, unused/alpha                                */
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_aspect.m[0][0] = 10.0f;     /*|*/   pp->m_partsys_aspect.m[1][0] = 10.0f;
    pp->m_partsys_aspect.m[0][1] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[1][1] = 1.0f;
    pp->m_partsys_aspect.m[0][2] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][2] = 1.0f;
    pp->m_partsys_aspect.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_aspect.m[2][0] = 10.0f;     /*|*/   pp->m_partsys_aspect.m[3][0] = 10.0f;
    pp->m_partsys_aspect.m[2][1] = 6.0f;      /*|*/   pp->m_partsys_aspect.m[3][1] = 0.0f;
    pp->m_partsys_aspect.m[2][2] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[3][2] = 1.0f;
    pp->m_partsys_aspect.m[2][3] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    pp->m_size_min_max[0] = 0.1f;
    pp->m_size_min_max[1] = 19.0f;//static_cast<f32>(nn::gx::DISPLAY0_HEIGHT) / 3.0f;

    pp->m_random_seed[0] = 735.0f;
    pp->m_random_seed[1] = 2.564f + pp->m_random_seed[0];
    pp->m_random_seed[2] = 1.15f + pp->m_random_seed[0];
    pp->m_random_seed[3] = 0.9875f + pp->m_random_seed[0];

    /* Core value for random
     Algorithm is based Pseudo-random number generators: X(n+1) = (a*Xn+b) mod m
     Expected values for uniform are
     [0] = a, [1] = b, [2] = m, [3] = 1/m
    */
    pp->m_prng[0] = 17.0f;                      /* a */
    pp->m_prng[1] = 37.0f;                      /* b */
    pp->m_prng[2] = 16777215.0f;                /* m */
    pp->m_prng[3] = 1.0f / (pp->m_prng[2]);     /* 1/m */

    pp->m_speed = 0.05f;                /*  emitter->particle_speed  */
    pp->m_particleCountMax = 150.0f;    /*  particle number          */

    /* Application only */
    pp->simulationTime = 10.0f;
    pp->NFrame = 512;
    pp->dTime = pp->simulationTime/pp->NFrame;
}

/*********************************************************************************************************/
/********************Spinning / Fake blurry effect********************************************************/
/*********************************************************************************************************/
/* all the control are in (0,0,0)
 Falling particles */
static void LoadParticleSystemSpin(struct _particleSys *pp)
{
    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point positions---------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_center.m[0][0] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][0] = 0.0f;
    pp->m_partsys_center.m[0][1] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][1] = 0.0f;
    pp->m_partsys_center.m[0][2] = 0.0f;  /*|*/   pp->m_partsys_center.m[1][2] = 0.0f;
    pp->m_partsys_center.m[0][3] = 1.0f;  /*|*/   pp->m_partsys_center.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_center.m[2][0] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][0] = 0.0f;
    pp->m_partsys_center.m[2][1] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][1] = 0.0f;
    pp->m_partsys_center.m[2][2] = 0.0f;  /*|*/   pp->m_partsys_center.m[3][2] = 0.0f;
    pp->m_partsys_center.m[2][3] = 1.0f;  /*|*/   pp->m_partsys_center.m[3][3] = 1.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 control point colors------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_color.m[0][0] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][0] = 0.0f;
    pp->m_partsys_color.m[0][1] = 0.0f;       /*|*/   pp->m_partsys_color.m[1][1] = 1.0f;
    pp->m_partsys_color.m[0][2] = 0.0f;       /*|*/   pp->m_partsys_color.m[1][2] = 0.0f;
    pp->m_partsys_color.m[0][3] = 1.0f;       /*|*/   pp->m_partsys_color.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_color.m[2][0] = 0.0f;       /*|*/   pp->m_partsys_color.m[3][0] = 1.0f;
    pp->m_partsys_color.m[2][1] = 1.0f;       /*|*/   pp->m_partsys_color.m[3][1] = 1.0f;
    pp->m_partsys_color.m[2][2] = 1.0f;       /*|*/   pp->m_partsys_color.m[3][2] = 1.0f;
    pp->m_partsys_color.m[2][3] = 0.0f;       /*|*/   pp->m_partsys_color.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the 4 bounding boxes------------------------------------------*/
    /*--------Radii in X, Y and Z direction. W not used ----------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_radius.m[0][0] = 0.0f;      /*|*/   pp->m_partsys_radius.m[1][0] = 0.0f;
    pp->m_partsys_radius.m[0][1] = 0.0f;      /*|*/   pp->m_partsys_radius.m[1][1] = 0.0f;
    pp->m_partsys_radius.m[0][2] = 0.0f;      /*|*/   pp->m_partsys_radius.m[1][2] = 0.0f;
    pp->m_partsys_radius.m[0][3] = 0.0f;      /*|*/   pp->m_partsys_radius.m[1][3] = 0.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_radius.m[2][0] = 0.0f;      /*|*/   pp->m_partsys_radius.m[3][0] = 0.0f;
    pp->m_partsys_radius.m[2][1] = 0.0f;      /*|*/   pp->m_partsys_radius.m[3][1] = 0.0f;
    pp->m_partsys_radius.m[2][2] = 0.0f;      /*|*/   pp->m_partsys_radius.m[3][2] = 0.0f;
    pp->m_partsys_radius.m[2][3] = 0.0f;      /*|*/   pp->m_partsys_radius.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/

    /*------------------------------------------------------------------------------------*/
    /*--------Definition of the particle aspect-------------------------------------------*/
    /*--------Particle size, texture coordinates !!!??TBD   ------------------------------*/
    /*------------------------------------------------------------------------------------*/
    /*Rotation disabled: Size, unused,unused,unused/alpha                                 */
    /*Rotation Enabled:  Size, Angle, Radius, unused/alpha                                */
    /*-----------Control Point 1---------------------Control Point 2----------------------*/
    pp->m_partsys_aspect.m[0][0] = 30.0f;     /*|*/   pp->m_partsys_aspect.m[1][0] = 30.0f;
    pp->m_partsys_aspect.m[0][1] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[1][1] = -3.1415f / 0.15f;
    pp->m_partsys_aspect.m[0][2] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][2] = 1.0f;
    pp->m_partsys_aspect.m[0][3] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[1][3] = 1.0f;
    /*-----------Control Point 3---------------------Control Point 4----------------------*/
    pp->m_partsys_aspect.m[2][0] = 30.0f;     /*|*/   pp->m_partsys_aspect.m[3][0] = 30.0f;
    pp->m_partsys_aspect.m[2][1] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[3][1] = 3.1415f / 0.15f;
    pp->m_partsys_aspect.m[2][2] = 1.0f;      /*|*/   pp->m_partsys_aspect.m[3][2] = 1.0f;
    pp->m_partsys_aspect.m[2][3] = 0.0f;      /*|*/   pp->m_partsys_aspect.m[3][3] = 0.0f;
    /*------------------------------------------------------------------------------------*/
    /*------------------------------------------------------------------------------------*/
    pp->m_size_min_max[0] = 1.0f;
    pp->m_size_min_max[1] = static_cast<f32>(nn::gx::DISPLAY0_HEIGHT) / 2.0f;

    pp->m_random_seed[0] = 735.0f;
    pp->m_random_seed[1] = 2.564f + pp->m_random_seed[0];
    pp->m_random_seed[2] = 1.15f + pp->m_random_seed[0];
    pp->m_random_seed[3] = 0.9875f + pp->m_random_seed[0];

    /* Core value for random
     Algorithm is based Pseudo-random number generators: X(n+1) = (a*Xn+b) mod m
     Expected values for uniform are
     [0] = a, [1] = b, [2] = m, [3] = 1/m
    */
    pp->m_prng[0] = 147.0f;                     /* a */
    pp->m_prng[1] = 17.0f;                      /* b */
    pp->m_prng[2] = 256847.0f;                  /* m */
    pp->m_prng[3] = 1.0f / (pp->m_prng[2]);     /* 1/m */

    pp->m_speed = 0.15f;                /*  emitter->particle_speed  */
    pp->m_particleCountMax = 5.0f;  /*  particle number          */

    /* Application only */
    pp->simulationTime = 10.0f;
    pp->NFrame = 512;
    pp->dTime = pp->simulationTime/pp->NFrame;
}

/**********************************************************************************************************/
/********************Particle Pattern selector*************************************************************/
/**********************************************************************************************************/

void LoadParticlePattern(struct _particleSys *pp, PARTSYS_PATTERN pt)
{
    switch(pt)
    {
        case PARTSYS_EXPLOSION1:    LoadParticleSystemExplositon1(pp);     break;
        case PARTSYS_EXPLOSION2:    LoadParticleSystemExplositon2(pp);     break;
        case PARTSYS_SNOW:          LoadParticleSystemSnow(pp);            break;
        case PARTSYS_SPIN:          LoadParticleSystemSpin(pp);            break;
        case PARTSYS_DEFAULT: 
        default:
                                    LoadParticleSystem1(pp);               break;
    }
}
