﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     binFileUtil.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef _BIN_FILE_UTIL_h__
#define _BIN_FILE_UTIL_h__

class CBinalyFile
{
public:

    CBinalyFile();
    ~CBinalyFile();

public:
    // read data the file
    bool load(const char *szFilePath);

    /// pointer to the data
    operator const void *() const { return m_data; }

    /// data accessors
    const void *getData(void) const { return m_data; }  
    unsigned int GetSize(void) const { return m_size; }

private:
    // data read from the file
    void*           m_data;

    // pointer to the memory block that should be freed up
    unsigned char*  m_ownMemory;

    // file size
    long long int   m_size;
};

#endif // _BIN_FILE_UTIL_h__
