﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     PrimitiveUtils.h

  Copyright (C)2009-2011 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46392 $
 *---------------------------------------------------------------------------*/

#ifndef _PRIMITIVE_UTILS_H_
#define _PRIMITIVE_UTILS_H_

#define BOX_VERTEX_NUM 36

// Vertex stream (Position)
static const f32 s_BoxVtxStreamPos[ BOX_VERTEX_NUM * 3 ] =
{
    -0.5f,  0.5f,  0.5f,   -0.5f,  0.5f, -0.5f,   -0.5f, -0.5f, -0.5f,
    -0.5f, -0.5f,  0.5f,   -0.5f,  0.5f,  0.5f,   -0.5f, -0.5f, -0.5f,
     0.5f,  0.5f,  0.5f,   -0.5f,  0.5f,  0.5f,   -0.5f, -0.5f,  0.5f,
     0.5f, -0.5f,  0.5f,    0.5f,  0.5f,  0.5f,   -0.5f, -0.5f,  0.5f,
     0.5f,  0.5f, -0.5f,    0.5f,  0.5f,  0.5f,    0.5f, -0.5f, -0.5f,
     0.5f, -0.5f, -0.5f,    0.5f,  0.5f,  0.5f,    0.5f, -0.5f,  0.5f,
    -0.5f,  0.5f, -0.5f,    0.5f,  0.5f, -0.5f,   -0.5f, -0.5f, -0.5f,
     0.5f,  0.5f, -0.5f,    0.5f, -0.5f, -0.5f,   -0.5f, -0.5f, -0.5f,
    -0.5f, -0.5f, -0.5f,    0.5f, -0.5f, -0.5f,   -0.5f, -0.5f,  0.5f,
    -0.5f, -0.5f,  0.5f,    0.5f, -0.5f, -0.5f,    0.5f, -0.5f,  0.5f,
    -0.5f,  0.5f, -0.5f,   -0.5f,  0.5f,  0.5f,    0.5f,  0.5f, -0.5f,
    -0.5f,  0.5f,  0.5f,    0.5f,  0.5f,  0.5f,    0.5f,  0.5f, -0.5f,
};

// Vertex stream (TexCoord0)
static const f32 s_BoxVtxStreamTex[ BOX_VERTEX_NUM * 2 ] =
{
    1.f, 1.f,  1.f, 0.f,  0.f, 0.f,
    0.f, 1.f,  1.f, 1.f,  0.f, 0.f,
    1.f, 1.f,  0.f, 1.f,  0.f, 0.f,
    1.f, 0.f,  1.f, 1.f,  0.f, 0.f,
    1.f, 0.f,  1.f, 1.f,  0.f, 0.f,
    0.f, 0.f,  1.f, 1.f,  0.f, 1.f,
    0.f, 1.f,  1.f, 1.f,  0.f, 0.f,
    1.f, 1.f,  1.f, 0.f,  0.f, 0.f,
    0.f, 0.f,  1.f, 0.f,  0.f, 1.f,
    0.f, 1.f,  1.f, 0.f,  1.f, 1.f,
    0.f, 0.f,  0.f, 1.f,  1.f, 0.f,
    0.f, 1.f,  1.f, 1.f,  1.f, 0.f,
};

// Vertex stream (Normal)
static const f32 s_BoxVtxStreamNrm[ BOX_VERTEX_NUM * 3 ] =
{
    -1.f,  0.f,  0.f,  -1.f,  0.f,  0.f,  -1.f,  0.f,  0.f,
    -1.f,  0.f,  0.f,  -1.f,  0.f,  0.f,  -1.f,  0.f,  0.f,
     0.f,  0.f,  1.f,   0.f,  0.f,  1.f,   0.f,  0.f,  1.f,
     0.f,  0.f,  1.f,   0.f,  0.f,  1.f,   0.f,  0.f,  1.f,
     1.f,  0.f,  0.f,   1.f,  0.f,  0.f,   1.f,  0.f,  0.f,
     1.f,  0.f,  0.f,   1.f,  0.f,  0.f,   1.f,  0.f,  0.f,
     0.f,  0.f, -1.f,   0.f,  0.f, -1.f,   0.f,  0.f, -1.f,
     0.f,  0.f, -1.f,   0.f,  0.f, -1.f,   0.f,  0.f, -1.f,
     0.f, -1.f,  0.f,   0.f, -1.f,  0.f,   0.f, -1.f,  0.f,
     0.f, -1.f,  0.f,   0.f, -1.f,  0.f,   0.f, -1.f,  0.f,
     0.f,  1.f,  0.f,   0.f,  1.f,  0.f,   0.f,  1.f,  0.f,
     0.f,  1.f,  0.f,   0.f,  1.f,  0.f,   0.f,  1.f,  0.f,
} ;

    // Vertex stream (Color)
static const f32 s_BoxVtxStreamClr[ BOX_VERTEX_NUM * 4 ] =
{
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f,  1.0f, 1.0f, 1.0f, 1.0f
} ;
        
// hexahedron vertex index
static const u8 s_BoxVtxStreamIdx[ BOX_VERTEX_NUM * 1 ] =
{
     0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,
    12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
    24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35
};


template < int COL_NUM, int ROW_NUM >
struct TPrimitiveSphere
{
    enum
    {
        VERTEX_NUM = COL_NUM * ( ROW_NUM - 1 ) * 6
    };
    
    f32 streamPos[ ROW_NUM * COL_NUM ][ 3 ];
    f32 streamTex[ ROW_NUM * COL_NUM  * 2 ];
    f32 streamNrm[ ROW_NUM * COL_NUM ][ 3 ];
    f32 streamClr[ ROW_NUM * COL_NUM ][ 4 ];
    u16 streamIdx[ VERTEX_NUM ];

    void SetupVtxStream( void )
    {
        const f32 delta_row = nn::math::F_PI / (ROW_NUM - 1);
        const f32 delta_col = 2 * nn::math::F_PI / (COL_NUM - 1);
        
        for(int row = 0; row < ROW_NUM; row++)
        {
            for(int col = 0; col < COL_NUM; col++)
            {
                int index = row * COL_NUM + col;
                f32 sin_row, cos_row, sin_col, cos_col;

                nn::math::SinCosRad( &sin_row, &cos_row, delta_row * row );
                nn::math::SinCosRad( &sin_col, &cos_col, delta_col * col );
                
                streamPos[ index ][ 0 ] = streamNrm[ index ][ 0 ] = 0.5f * sin_row * cos_col;
                streamPos[ index ][ 1 ] = streamNrm[ index ][ 1 ] = 0.5f * cos_row;
                streamPos[ index ][ 2 ] = streamNrm[ index ][ 2 ] = 0.5f * sin_row * sin_col;
            }
        }

        std::memset( streamTex, 0, sizeof( streamTex ) );
        std::memset( streamClr, 1.f, sizeof( streamClr ) );
        
        for(int i = 0, row = 0; row < ROW_NUM - 1; row++)
        {
#define __INDEX(ROW, COL)   ((ROW) * COL_NUM + (COL))
            for(int col = 0; col < COL_NUM; col++)
            {
                streamIdx[i++] = __INDEX( row,     col     );
                streamIdx[i++] = __INDEX( row,     col + 1 );
                streamIdx[i++] = __INDEX( row + 1, col     );
                streamIdx[i++] = __INDEX( row + 1, col     );
                streamIdx[i++] = __INDEX( row,     col + 1 );
                streamIdx[i++] = __INDEX( row + 1, col + 1 );
            }
#undef __INDEX
        }
        
        nngxUpdateBuffer( this, sizeof( TPrimitiveSphere< COL_NUM, ROW_NUM > ));
    }
};

typedef TPrimitiveSphere<7,6> PrimitiveSphere;



template < int COL_NUM, int ROW_NUM >
struct TPrimitiveInterleavedSphere
{
    enum
    {
        VERTEX_NUM = COL_NUM * ( ROW_NUM - 1 ) * 6
    };

    struct Stream
    {
        f32 pos[3];
        f32 tex[2];
        f32 clr[4];
        f32 nrm[3];
    } stream[ ROW_NUM * COL_NUM ];
    u16 streamIdx[ VERTEX_NUM ];

    u32 vertexCount;

    void SetupVtxStream()
    {
        vertexCount = VERTEX_NUM;

        const f32 delta_row = nn::math::F_PI / (ROW_NUM - 1);
        const f32 delta_col = 2 * nn::math::F_PI / (COL_NUM - 1);
        
        for(int row = 0; row < ROW_NUM; row++)
        {
            for(int col = 0; col < COL_NUM; col++)
            {
                Stream* p_stream = &stream[ row * COL_NUM + col ];
                f32 sin_row, cos_row, sin_col, cos_col;

                nn::math::SinCosRad( &sin_row, &cos_row, delta_row * row );
                nn::math::SinCosRad( &sin_col, &cos_col, delta_col * col );
                
                p_stream->pos[ 0 ] = p_stream->nrm[ 0 ] = 0.5f * sin_row * cos_col;
                p_stream->pos[ 1 ] = p_stream->nrm[ 1 ] = 0.5f * cos_row;
                p_stream->pos[ 2 ] = p_stream->nrm[ 2 ] = 0.5f * sin_row * sin_col;

                p_stream->tex[ 0 ] = 0.f;
                p_stream->tex[ 1 ] = 0.f;

                p_stream->clr[ 0 ] = 1.0f;
                p_stream->clr[ 1 ] = 1.0f;
                p_stream->clr[ 2 ] = 1.0f;
                p_stream->clr[ 3 ] = 1.0f;
            }
        }
        
        for(int i = 0, row = 0; row < ROW_NUM - 1; row++)
        {
#define __INDEX(ROW, COL)   ((ROW) * COL_NUM + (COL))
            for(int col = 0; col < COL_NUM; col++)
            {
                streamIdx[i++] = __INDEX( row,     col     );
                streamIdx[i++] = __INDEX( row,     col + 1 );
                streamIdx[i++] = __INDEX( row + 1, col     );
                streamIdx[i++] = __INDEX( row + 1, col     );
                streamIdx[i++] = __INDEX( row,     col + 1 );
                streamIdx[i++] = __INDEX( row + 1, col + 1 );
            }
#undef __INDEX
        }
    }
};

typedef TPrimitiveInterleavedSphere<7,6> PrimitiveInterleavedSphere;


#endif // _PRIMITIVE_UTILS_H_
