//
//------------------------------------------------------------
// Copyright(c) 2009-2010 by Digital Media Professionals Inc.
// All rights reserved.
//------------------------------------------------------------
// This source code is the confidential and proprietary
// of Digital Media Professionals Inc.
//------------------------------------------------------------
//

// Input registers map
#define aPosition       v0
#define aColor          v1

// Output registers map
#define vPosition       o0
#define vQuaternion     o1
#define vView           o2
#define vTexCoord       o3

#define dmp_projection_matrix           c0
#define dmp_local_to_view_matrix        c4
#define dmp_local_to_world_matrix       c8
#define TEMP_VIEW           r15

#pragma bind_symbol(aPosition.xyzw,v0,v0)
#pragma bind_symbol(aColor.xyz,v1,v1)

#pragma output_map (position, o0)
#pragma output_map (color,    o1)

#pragma bind_symbol(uProjection,c0,c3)
#pragma bind_symbol(uModelView,c4,c7)

l_position:
    m4x4    TEMP_VIEW,        aPosition,          dmp_local_to_view_matrix
	m4x4     vPosition,       TEMP_VIEW,          dmp_projection_matrix
    ret
    nop

main:
    call    l_position
    mov     o1, aColor
    end
endmain:
