﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     gr_GfxAllocator.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef GR_GFX_ALLOCATOR_H_
#define GR_GFX_ALLOCATOR_H_

#include "gr_MemoryMgr.h"

class GfxAllocator
{
public:
    virtual void Initialize( void );
    virtual void Finalize( void );
    virtual void * Allocate( GLenum area, GLenum aim, GLuint id, GLsizei size );
    virtual void Deallocate( GLenum area, GLenum aim, GLuint id, void *addr );

    GfxAllocator( MemoryMgr::AllocatorDevice *allocator )
        : m_Initialized( false )
        , m_CurrentAddrVramA( NULL )
        , m_CurrentAddrVramB( NULL )
        , m_AllocatorDev( allocator )
    {
    }

    virtual ~GfxAllocator()
    {
        Finalize();
    }
    
private:
    bool    m_Initialized;
    NN_PADDING3;

    uptr    m_CurrentAddrVramA;
    uptr    m_CurrentAddrVramB;
    
    MemoryMgr::AllocatorDevice * m_AllocatorDev;
};

#endif // GR_GFX_ALLOCATOR_H_
