﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     gr_Scene.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef GR_SCENE_H_
#define GR_SCENE_H_

#include <nn/gr.h>

class IScene
{
public:
    IScene(void)
    {
    }

    virtual ~IScene(void)
    {
    }

    virtual bool   Initialize( void ) PURE;
    virtual void   Finalize( void )   PURE;
    virtual void   Enter( void )      PURE;
    virtual bool   Calc( void )       PURE;
    virtual void   PreDraw( void )    PURE;
    virtual GLuint DrawTop( void )    PURE;
    virtual GLuint DrawBtm(void )     PURE;
    virtual GLuint DrawExt( void )    PURE;
    virtual void   PostDraw( void )   PURE;
    virtual nn::gr::CTR::FrameBuffer::ColorBuffer* GetGrColorBufferPointer( void ) PURE;
};

#endif // GR_SCENE_H_
