﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     gr_Common.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include "gr_Inner.h"
#include "gr_Common.h"
#include "gr_MemoryMgr.h"



//------------------------------------------------------------------------------
void *operator new( size_t size, const std::nothrow_t& ) throw()
{
    return MEMMGR->AllocateFCRAM( size, 4 );
}

void *operator new[]( size_t size, const std::nothrow_t& ) throw()
{
    return MEMMGR->AllocateFCRAM( size, 4 );
}

void *operator new( size_t size, int alignment ) throw()
{
    return MEMMGR->AllocateFCRAM( size, alignment );
}

void *operator new[]( size_t size, int alignment ) throw()
{
    return MEMMGR->AllocateFCRAM( size, alignment );
}

void  operator delete( void* ptr ) throw()
{
    MEMMGR->Free( ptr );
}

void  operator delete[]( void* ptr ) throw()
{
    MEMMGR->Free( ptr );
}

//--------------------------------------------------------------------------
void *Alloc( size_t size, u8 alignment ) 
{
    return MEMMGR->AllocateFCRAM ( size, alignment );
}

void *AllocDeviceMemory( size_t size, u8 alignment )
{
    return MEMMGR->AllocateDevice( size, alignment );
}

void  Free( void *memory )
{
    MEMMGR->Free( memory );
}
