/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     gr_PrimitiveVertexStream.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include "gr_PrimitiveVertexStream.h"

namespace
{
    // Vertex stream (Position)
    const f32 s_ParticleVtxStreamPos[ PrimitiveParticle::VERTEX_NUM * 1 ] =
    {
        0.0f, 1.0f, 2.0f, 3.0f
    };

    // Vertex index
    const u8 s_ParticleVtxStreamIdx[ PrimitiveParticle::VERTEX_NUM * 1 ] =
    {
        0, 1, 2, 3
    };
}

//------------------------------------------------------------------------------
void PrimitiveParticle::SetupVtxStream( void )
{
    std::memcpy( streamPos, s_ParticleVtxStreamPos, sizeof( s_ParticleVtxStreamPos ) );
    std::memcpy( streamIdx, s_ParticleVtxStreamIdx, sizeof( s_ParticleVtxStreamIdx ) );

    nngxUpdateBuffer( this, sizeof( PrimitiveParticle ) );
}
