﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     gr_PrimitiveVertexStream.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef GR_PRIMITIVE_VERTEX_STREAM_H_
#define GR_PRIMITIVE_VERTEX_STREAM_H_

#include <nn/gr.h>

#pragma diag_suppress 2530  // #2530: padding added to end of struct GraphicSystem

struct PrimitivePoint
{
    static const u32 VERTEX_NUM = 3;
    
    f32 streamPos [ VERTEX_NUM * 4 ];
    f32 streamCol [ VERTEX_NUM * 3 ];
    f32 streamSize[ VERTEX_NUM * 1 ];
    u8  streamIdx [ VERTEX_NUM * 1 ];

    void SetupVtxStream( void );
};

#pragma diag_default 2530

#endif // GR_PRIMITIVE_VERTEX_STREAM_H_
