﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     gr_PrimitiveVertexStream.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include "gr_PrimitiveVertexStream.h"

namespace
{
    const f32 s_PointVtxStreamPos[PrimitivePoint::VERTEX_NUM * 4] = 
    {
         0.5f, 0.0f, 0.f, 1.f,
        -0.5f, 0.5f, 0.f, 1.f,
        -0.5f,-0.5f, 0.f, 1.f
    };
    const f32 s_PointVtxStreamCol[ PrimitivePoint::VERTEX_NUM * 3 ] = 
    {
        1.f, 0.0f, 0.0f,
        0.f, 1.0f, 0.0f,
        0.f, 0.0f, 1.0f
    };
    const f32 s_PointVtxStreamSize[ PrimitivePoint::VERTEX_NUM * 1 ] = 
    {
        40.f, 20.f, 100.f
    };

    const u8 s_PointVtxStreamIdx[ PrimitivePoint::VERTEX_NUM * 1 ] = 
    {
        0, 1, 2
    };
}


//------------------------------------------------------------------------------
void PrimitivePoint::SetupVtxStream()
{
    std::memcpy( streamPos, s_PointVtxStreamPos, sizeof( s_PointVtxStreamPos ) );
    std::memcpy( streamCol, s_PointVtxStreamCol, sizeof( s_PointVtxStreamCol ) );
    std::memcpy( streamSize, s_PointVtxStreamSize, sizeof( s_PointVtxStreamSize ) );
    std::memcpy( streamIdx, s_PointVtxStreamIdx, sizeof( s_PointVtxStreamIdx ) );

    nngxUpdateBuffer( this, sizeof( PrimitivePoint ));
}
