// Input registers map
#define aPosition       v0
#define aTexCoord       v1

// Output registers map
#define vPosition       o0
#define vTexcoord       o1

// Temporary registers map
#define TEMP_VIEW       r15

// Constant registers map
#define projectionMatrix    c0
#define localViewMatrix     c4

#pragma bind_symbol(aPosition.xyz,v0,v0)
#pragma bind_symbol(aTexCoord.xy,v1,v1)

#pragma bind_symbol(uProjection,c0,c3)
#pragma bind_symbol(uModelView,c4,c7)

#pragma output_map ( position, o0 )
#pragma output_map ( texture0, o1 )

main:
    m4x4    TEMP_VIEW,      aPosition,      localViewMatrix
	m4x4    vPosition,     TEMP_VIEW,      projectionMatrix
    mov     vTexcoord,      aTexCoord
    end
endmain:

