﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     Application.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef APPLICATION_H_
#define APPLICATION_H_

#include <nn.h>
#include <demo.h>
#include <scene.h>
#include "SaveData.h"

namespace SampleDemos {
namespace hid {
namespace ExtraPad {
namespace AppRecommendedFlow {

/* Please see man pages for details 
    
*/
class Application
{
public:
    /* Please see man pages for details 
        
    */
    static void AcquireInstance();

    /* Please see man pages for details 
        
    */
    static void ReleaseInstance();

    /* Please see man pages for details 
        

        
    */
    static Application* GetInstance();

protected:
    /* Please see man pages for details 
        
    */
    Application();

    /* Please see man pages for details 
        
    */
    virtual ~Application();
    NN_PADDING4;

public:
    /* Please see man pages for details 
        

        
    */
    demo::RenderSystemDrawing* GetRenderSystem();

    /* Please see man pages for details 
        

        
    */
    scene::TextWriter* GetTextWriter();

    // Related to Circle Pad Pro detection thread
    static void DetectExtraPadThread();

    SaveData m_saveData;                    // SaveData class instance
    SaveData::SaveDataStruct m_saveDataSet; // Information to save to save data
    SaveDataId m_SelectedSaveData;          // ID of selected save data

    // First time connecting Circle Pad Pro in scene that uses it?
    bool m_IsFirstConnect;
    NN_PADDING2;
    NN_PADDING4;

protected:
    // Renderer
    demo::RenderSystemDrawing m_renderSystem;

    // Renderer buffer
    uptr m_pGxBuffer;

    // Text writer
    scene::TextWriter m_textWriter;

    // Counter
    u32 m_Counter;
};

}}}} // Namespace

#endif // APPLICATION_H_
