﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     ExtraPadDetection.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef EXTRA_PAD_DETECTION_H_
#define EXTRA_PAD_DETECTION_H_

#include <nn/os.h>
#include <nn/hid/CTR/hid_ExtraPadReader.h>
#include <nn/hid/CTR/hid_ExtraPadStatus.h>

namespace SampleDemos {
namespace hid {
namespace ExtraPad {
namespace AppRecommendedFlow {

// Performs initialization.
// If no arguments were specified, initialize and start detection at the same time.
// Add "false" to arguments to initialize without starting detection.
void InitializeExtraPadDetection(bool isStartThread = true);

// Finalizes.
void FinalizeExtraPadDetection();

// Start detection thread
void StartDetectExtraPadThread();

// Stop detection thread
void StopDetectExtraPadThread();

// Confirm whether detection thread has been run
// Returns true if running, false otherwise.
bool IsAliveDetectExtraPadThread();

// Circle Pad Pro detection thread function.
void DetectExtraPadThreadFunc();

}}}}

#endif // EXTRA_PAD_DETECTION_H_
