﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     MySceneFactory.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include "MySceneFactory.h"
#include "SceneId.h"

#include "SceneSelectSaveData.h"
#include "SceneOperateSaveData.h"
#include "SceneConfirmDetection.h"
#include "SceneUseExtraPad.h"
#include "SceneOptionMenu.h"


namespace SampleDemos {
namespace hid {
namespace ExtraPad {
namespace AppRecommendedFlow {

scene::Scene* MySceneFactory::Generate(s32 sceneId)
{
    switch (sceneId)
    {
        case SCENE_ID_EP_SELECT_SAVE_DATA:         // At save data selection
            return new SceneSelectSaveData();
        case SCENE_ID_EP_OPERATE_SAVE_DATA:        // Save data operations (load / delete)
            return new SceneOperateSaveData();
        case SCENE_ID_EP_CONFIRM_DETECTION:        // Confirm connection after selecting save data
            return new SceneConfirmDetection();
        case SCENE_ID_EP_USE_EXTRA_PAD:            // Scene that uses Circle Pad Pro
            return new SceneUseExtraPad();
        case SCENE_ID_EP_OPTION_MENU:              // Options menu
            return new SceneOptionMenu();
    }

    return NULL;
}

}}}}
