﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     SceneConfirmDetection.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef SCENE_CONFIRM_DETECTION_H_
#define SCENE_CONFIRM_DETECTION_H_

#include "Common.h"

namespace SampleDemos {
namespace hid {
namespace ExtraPad {
namespace AppRecommendedFlow {

class SceneConfirmDetection : public scene::Scene
{
public:
    /* Please see man pages for details 
        
    */
    SceneConfirmDetection() {}

    /* Please see man pages for details 
        
    */
    virtual ~SceneConfirmDetection() {}

    /* Please see man pages for details 
        

        
    */
    virtual bool Initialize();

    /* Please see man pages for details 
        
    */
    virtual void Finalize();

    /* Please see man pages for details 
        
    */
    virtual void Update();

    /* Please see man pages for details 
        
    */
    virtual void Draw();

private:
    // Event callback
    static void MyControlEventCallback(scene::ControlEvent event, scene::ControlBase* pControl, s16 x, s16 y, void* pParam);

private:
    // State
    s32 m_State;
    // Counter (for displaying busy icon)
    u32 m_Counter;

    NN_PADDING4;

    // GUI manager
    scene::ControlManager m_ControlManager;

    // Detection wait time
    nn::os::Tick m_StartDetectionTick;

    // Message
    static const wchar_t* MESSAGES_ASK_TO_USE[];
    static const wchar_t* MESSAGES_CONNECTION_SUCCESS[];
    static const wchar_t* MESSAGES_SETTING_ON[];
    static const wchar_t* MESSAGES_DETECTING[];
    static const wchar_t* MESSAGES_CANT_DETECT[];
    static const wchar_t* MESSAGES_REMOVED[];
    static const wchar_t* MESSAGES_LOW_BATTERY[];

};

}}}}

#endif // SCENE_SHOW_FIRST_TIME_MESSAGE_H_
