﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     SceneUseExtraPad.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef SCENE_USE_EXTRA_PAD_H_
#define SCENE_USE_EXTRA_PAD_H_

#include "Common.h"

namespace SampleDemos {
namespace hid {
namespace ExtraPad {
namespace AppRecommendedFlow {

enum MessageType
{
    MESSAGE_DISCONNECT,  // Disconnection message
    MESSAGE_CONNECT,     // Connection message
    MESSAGE_LOW_BATTERY, // Battery level low
    MESSAGE_NONE,        // No message

    MESSAGE_MAX
};

class SceneUseExtraPad : public scene::Scene
{
public:
    /* Please see man pages for details 
        
    */
    SceneUseExtraPad() {}

    /* Please see man pages for details 
        
    */
    virtual ~SceneUseExtraPad() {}

    /* Please see man pages for details 
        

        
    */
    virtual bool Initialize();

    /* Please see man pages for details 
        
    */
    virtual void Finalize();

    /* Please see man pages for details 
        
    */
    virtual void Update();

    /* Please see man pages for details 
        
    */
    virtual void Draw();

    /* Please see man pages for details 
        
    */
    void UpdateObjectState();

public:
    NN_PADDING4;
    // Class that gets information from the Circle Pad Pro and the game pad on the CTR system
    nn::hid::ExtraPadReader m_ExtraPadReader;
    nn::hid::ExtraPadStatus m_ExtraPadStatus;
    nn::hid::ExtraPadStatus m_ExtraPadStatusArray[32];

    // Class that gets information from the game pad on the CTR system
    nn::hid::PadReader m_PadReader;
    nn::hid::PadStatus m_PadStatus;
    nn::hid::PadStatus m_PadStatusArray[32];

    s32 m_ExtraPadReadLen;
    s32 m_PadReadLen;


private:
    // GUI manager
    scene::ControlManager     m_ControlManager;

    // Detect changes in connection state
    nn::os::LightEvent        m_ConnectionEvent;

    // State
    s32 m_State;

    // Common information used for message display
    struct{
        f32  textHeight;    // Character height
        f32  displayY;      // Height of message during display
        u32  counter;       // Counter
        bool isInitialized; // Flag for determining initialization
        NN_PADDING3;
    }m_MessageProperty;

    bool m_IsLowBattery;    // Flag related to battery level

    // Type of message specific to state changes
    MessageType m_MessageType;
    NN_PADDING2;
};

}}}}

#endif // SCENE_USE_EXTRA_PAD_H_
