﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     os_BlockingQueueDemo.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/os.h>

/* Please see man pages for details 
    
    
*/
/* Please see man pages for details 
    
    
*/
/* Please see man pages for details 
    
    
    
    
    
*/

/* Please see man pages for details 
  

                

  

  
*/
void EnqueueThreadFunc(nn::os::BlockingQueue* pQueue)
{
    NN_LOG(" Enqueue Thraed Start\n");
    for(int i = 0; i < 10; i++)
    {
        NN_LOG("  Try to Enqueue(%d)\n", i);
        pQueue->Enqueue(i);
        NN_LOG("  Enqueue(%d)\n", i);
    }
    NN_LOG(" Enqueue Thraed End\n");
}

/* Please see man pages for details 
  

                

  

  
*/
void EnqueueThreadFunc2(nn::os::BlockingQueue* pQueue)
{
    NN_LOG(" Enqueue Thraed Start\n");
    for(int i = 0; i < 10; i++)
    {
        NN_LOG("  Enqueue(%d)\n", i);
        pQueue->Enqueue(i);
    }
    NN_LOG(" Enqueue Thraed End\n");
}

/* Please see man pages for details 
  

                

  
*/
void BlockingQueueDemo1()
{
    NN_LOG("-- BlockingQueue Demo1 --\n");

    nn::os::BlockingQueue queue;
    const size_t SIZE = 5;
    uptr buffer[SIZE];
    nn::os::Thread enqueueThread;
    nn::os::StackMemoryBlock stack(4096);


    //----------------------------------------------------------------
    // Demo of blocking queue that generates dequeue wait
    NN_LOG("** Waiting Dequeue Demo. **\n");
    // Initialize blocking queue
    queue.Initialize(buffer, SIZE);

    // Use thread to insert data at the end of the queue
    enqueueThread.Start(EnqueueThreadFunc, &queue, stack, nn::os::DEFAULT_THREAD_PRIORITY - 1);

    // Remove data from the head of the queue
    for(int i = 0; i < 10; i++)
    {
        int data = queue.Dequeue();
        NN_LOG("Dequeue(%d)\n", data);
    }

    // Join/discard threads
    enqueueThread.Join();
    enqueueThread.Finalize();
    // Discard blocking queue
    queue.Finalize();


    //----------------------------------------------------------------
    // Demo of blocking queue that generates enqueue wait
    NN_LOG("** Waiting Enqueue Demo. **\n");
    // Initialize blocking queue
    nn::os::BlockingQueue queue2;
    queue2.Initialize(buffer, SIZE);

    // Use thread to insert data at the end of the queue
    enqueueThread.Start(EnqueueThreadFunc2, &queue2, stack, nn::os::DEFAULT_THREAD_PRIORITY + 1);

    // Remove data from the head of the queue
    for(int i = 0; i < 10; i++)
    {
        NN_LOG("Try to Dequeue(%d)\n", i);
        int data = queue2.Dequeue();
        NN_LOG("Dequeue(%d)\n", data);
    }

    // Join thread
    enqueueThread.Join();
    // Discard blocking queue
    queue2.Finalize();
}

/* Please see man pages for details 
  

                

  
*/
void BlockingQueueDemo()
{
    NN_LOG("*** BlockingQueue Demo starts. ***\n");

    BlockingQueueDemo1();

    NN_LOG("*** End of BlockingQueue Demo ***\n");
}


/*  

*/

/*  

*/

/*  

*/
