﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     os_Main.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn.h>
#include <nn/applet.h>

#include "os_DemoUtil.h"

extern void MemoryDemo();
extern void ThreadDemo();
extern void MutexDemo();
extern void SemaphoreDemo();
extern void EventDemo();
extern void TimerDemo();
extern void AlarmDemo();
extern void BlockingQueueDemo();
extern void TickDemo();
extern void CriticalSectionDemo();

/* Please see man pages for details 
    
    
    
*/

/* Please see man pages for details 

    
    
    

*/

/* Please see man pages for details 
    
    
    
*/

/* Please see man pages for details 
    
    
*/

//extern "C" void nninitStartUp(void)
//{
//}

extern "C" void nnMain( void )
{
    // Call only the nn::applet::Enable function to also allow execution from the HOME Menu
    // HOME Menu transitions, POWER Button presses, and sleep are all unsupported
    nn::applet::Enable();

    NN_LOG("nnMain starts.\n");

    DemoUtil::DumpObjectCounts();

    //----------------------------------------------------------------
    // Memory demo
    MemoryDemo();

    // Thread demo
    ThreadDemo();

    // Mutex demo
    MutexDemo();

    // Semaphore demo
    SemaphoreDemo();

    // Event demo
    EventDemo();

    // Timer demo
    TimerDemo();

    // Tick demo
    TickDemo();

    // Alarm demo
    AlarmDemo();

    // Blocking queue demo
    BlockingQueueDemo();

    // Critical section demo
    CriticalSectionDemo();
    //----------------------------------------------------------------

    DemoUtil::DumpObjectCounts();

    NN_LOG("*** End of demo ***\n");
    while(true){}
}
/*  

*/

/*  

*/

