﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     os_SemaphoreDemo.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/os.h>

#include "os_DemoUtil.h"

/* Please see man pages for details 
    
    
*/
/* Please see man pages for details 
    
    
*/
/* Please see man pages for details 
    
    
    
    
    
*/

// Semaphores used in the demo
nn::os::Semaphore s_Semaphore;


/* Please see man pages for details 
  

                
                
                

  

  
*/
void SemaphoreDemoFunc(uptr param)
{
    u32 threadNum = param;

    // Performs processing after locking the semaphore.
    NN_LOG(" Thread %d, Trying wait semaphore\n", threadNum);
    s_Semaphore.Acquire();
    NN_LOG(" Thread %d, Success get semaphore\n", threadNum);
    for(int i = 0; i < 5; ++i)
    {
        NN_LOG("  Thread %d, i = %d\n", threadNum, i);
        nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMilliSeconds(1));
    }

    NN_LOG(" Thread %d, Release semaphore\n", threadNum);
    // Processing is finished so free the semaphore
    s_Semaphore.Release();

    NN_LOG(" Thread %d, END\n", threadNum);
}

/* Please see man pages for details 
  

                

  
*/
void SemaphoreDemo0()
{
    NN_LOG("-- Semaphore Demo0 --\n");

    // Create semaphore
    // Set initial count to 0 and maximum count to 5.
    s_Semaphore.Initialize(0, 5);

    DemoUtil::DumpObjectCounts();

    // Modify semaphore count
    for(int i = 0; i < 5; i++)
    {
        s32 count = s_Semaphore.Release(1);
#ifdef NN_BUILD_RELEASE
        NN_UNUSED_VAR(count);
#endif
        NN_LOG("semaphore count %d -> %d + 1\n", count, count);
    }

    // Discard semaphore
    s_Semaphore.Finalize();
}

/* Please see man pages for details 
  

                
                

  
*/
void SemaphoreDemo1()
{
    NN_LOG("-- Semaphore Demo1 --\n");

    // Create semaphore
    // Set initial count to 0 and maximum count to the number of threads - 2.
    NN_ASSERT(NN_DEMO_OS_MAX_THREAD_NUM - 2 > 0);
    s_Semaphore.Initialize( 0, NN_DEMO_OS_MAX_THREAD_NUM - 2 );

    // Creates thread
    nn::os::Thread threads[NN_DEMO_OS_MAX_THREAD_NUM];
    DemoUtil::CreateThreads(threads, SemaphoreDemoFunc, NN_DEMO_OS_MAX_THREAD_NUM);

    // Modify semaphore count
    s_Semaphore.Release( NN_DEMO_OS_MAX_THREAD_NUM - 2 );

    // Wait for thread termination
    DemoUtil::JoinThreads(threads, NN_DEMO_OS_MAX_THREAD_NUM);

    // Discard semaphore
    s_Semaphore.Finalize();
}

/* Please see man pages for details 
  

                

  
*/
void SemaphoreDemo()
{
    NN_LOG("*** Semaphore Demo starts. ***\n");

    SemaphoreDemo0();
    SemaphoreDemo1();

    NN_LOG("*** End of Semaphore Demo ***\n");
}

/*  

*/

/*  

*/

/*  

*/

