﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     os_ThreadDemo.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/os.h>

#include "os_DemoUtil.h"

/* Please see man pages for details 
    
    
*/
/* Please see man pages for details 
    
    
*/
/* Please see man pages for details 
    
    
    
    
    
*/

/* Please see man pages for details 
  
  
*/
struct ThreadParam{
    int threadNum;          //
    nn::os::Event* pWaitEvent;      //
    nn::os::Event* pSignalEvent;    //
};

/* Please see man pages for details 
  

                

  

  
*/
void ThreadDemoFunc(ThreadParam* param)
{
    for(int i = 0; i < 5; ++i)
    {
        param->pWaitEvent->Wait();
        NN_LOG("  Thread %d, count = %d\n", param->threadNum, i);
        param->pSignalEvent->Signal();
    }
    NN_LOG(" Thread %d END\n", param->threadNum);
}

/* Please see man pages for details 
  

                

  

  
*/
void SimpleThreadFunc(uptr param)
{
    NN_UNUSED_VAR(param);
    NN_LOG(" SimpleThreadFunc\n");
}

/* Please see man pages for details 
  

                

  
*/
 void ThreadDemo0()
{
    NN_LOG("-- Thread Demo0 --\n");

    const size_t STACK_SIZE = 4096;
    nn::os::Thread thread;
    nn::os::StackMemoryBlock stack;

    // Stack preparation
    stack.Initialize(STACK_SIZE);

    //----------------------------------------------------------------
    // Thread creation
    thread.Start(SimpleThreadFunc, NULL, stack);
    // Wait for thread termination
    thread.Join();
    // Discard thread
    thread.Finalize();

    //----------------------------------------------------------------
    // Create thread (specifying priority and core)
    thread.Start(SimpleThreadFunc, NULL, stack, nn::os::DEFAULT_THREAD_PRIORITY, 0);
    // Change the thread's priority
    s32 prior = thread.GetPriority();
    thread.ChangePriority(nn::os::DEFAULT_THREAD_PRIORITY + 1);
    NN_LOG("Thread Priority : %d -> %d\n", prior, thread.GetPriority());
    // Wait for thread termination
    thread.Join();
    // Discard thread
    thread.Finalize();
}

/* Please see man pages for details 
  

                

  
*/
 void ThreadDemo1()
{
    NN_LOG("-- Thread Demo1 --\n");

    nn::os::Thread thread1;
    ThreadParam threadParam1;
    nn::os::StackMemoryBlock stack1(4096);

    nn::os::Thread thread2;
    ThreadParam threadParam2;
    nn::os::StackBuffer<1024> stack2;
    
    // Event creation
    nn::os::Event event1(false);
    nn::os::Event event2(false);

    // Thread creation
    threadParam1.threadNum = 1;
    threadParam1.pWaitEvent = &event1;
    threadParam1.pSignalEvent = &event2;
    thread1.Start(ThreadDemoFunc, &threadParam1, stack1);

    threadParam2.threadNum = 2;
    threadParam2.pWaitEvent = &event2;
    threadParam2.pSignalEvent = &event1;
    thread2.Start(ThreadDemoFunc, &threadParam2, stack2);

    NN_LOG("Thread created.\n");
    DemoUtil::DumpObjectCounts();

    // Wakes Thread 1.
    // Thereafter, Thread 1 and Thread 2 alternately wake.
    event1.Signal();

    // Join thread
    thread1.Join();
    thread2.Join();
}

/* Please see man pages for details 
  

                

  
*/
void ThreadDemo()
{
    NN_LOG("*** Thread Demo starts. ***\n");

    ThreadDemo0();
    ThreadDemo1();

    NN_LOG("*** End of Thread Demo ***\n");
}

/*  

*/

/*  

*/

/*  

*/
