﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     os_TimerDemo.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/os.h>

#include "os_DemoUtil.h"

/* Please see man pages for details 
    
    
*/
/* Please see man pages for details 
    
    
*/
/* Please see man pages for details 
    
    
    
    
    
*/

/* Please see man pages for details 
  

                

  
*/
void TimerDemo1()
{
    NN_LOG("-- Timer Demo1 --\n");

    //----------------------------------------------------------------
    // Creates automatically resetting timer
    nn::os::Timer timer(false);

    DemoUtil::DumpObjectCounts();

    // Sets the one-shot timer for 1 second
    timer.StartOneShot(nn::fnd::TimeSpan::FromSeconds(1));

    // Wait for timer
    NN_LOG("Waiting Timer...\n");
    timer.Wait();
    NN_LOG("Timer Signaled.\n");

    // Periodic timer is set to 100 milliseconds initially and 10 milliseconds thereafter
    timer.StartPeriodic(nn::fnd::TimeSpan::FromMilliSeconds(100), nn::fnd::TimeSpan::FromMilliSeconds(10));

    for(int i = 0; i < 10; i++)
    {
        timer.Wait();
    }

    // Stops the timer
    timer.Stop();

    // Discards the timer
    timer.Finalize();


    //----------------------------------------------------------------
    // Creates manually resetting timer
    timer.Initialize(true);

    // Sets the one-shot timer for 1 second
    timer.StartOneShot(nn::fnd::TimeSpan::FromSeconds(1));

    // Wait for timer
    NN_LOG("Waiting Timer...\n");
    timer.Wait();
    NN_LOG("Timer Signaled.\n");

    // Timer automatically resets
    timer.ClearSignal();

    // Periodic timer is set to 100 milliseconds initially and 10 milliseconds thereafter
    timer.StartPeriodic(nn::fnd::TimeSpan::FromMilliSeconds(100), nn::fnd::TimeSpan::FromMilliSeconds(10));

    for(int i = 0; i < 10; i++)
    {
        timer.Wait();
        timer.ClearSignal();
    }

    // Stops the timer
    timer.Stop();

    // Discards the timer
    timer.Finalize();
}

/* Please see man pages for details 
  

                

  
*/
void TimerDemo()
{
    NN_LOG("*** Timer Demo starts. ***\n");

    TimerDemo1();

    NN_LOG("*** End of Timer Demo ***\n");
}


/*  

*/

/*  

*/

/*  

*/

