﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     rdt_UdsUtil.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev:$
 *---------------------------------------------------------------------------*/


#ifndef NN_SAMPLE_RDT_DEMO_RDT_UTIL_H_
#define NN_SAMPLE_RDT_DEMO_RDT_UTIL_H_

#include <nn/types.h>
#include <nn/hid.h>

// UDS library setup.
bool setupUds(void);


// UDS library cleanup.
void cleanupUds(void);


// Creates network. Assumes that Master side is calling.
bool createNetwork(void);

#ifdef SUPPORT_UDS_CLIENT
// Connect to network. Assumes that Client side is calling.
bool connectNetwork(void);


void printNetworkInfo(void *pScanBuf, size_t bufSize, u8 subId);
#endif

u16 GetPeerNodeId();
u16 GetMyNodeId();
void StartMonitorThread();
void StopMonitorThread();

#endif  // end of NN_SAMPLE_RDT_DEMO_RDT_UTIL_H_
