﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     mic.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLE_DEMOS_DEMO1_MIC_H_
#define NN_SAMPLE_DEMOS_DEMO1_MIC_H_

#include "../device.h"

class MicDemo : public Device
{
public:
    MicDemo(){}
    ~MicDemo(){}

    virtual void Initialize(demo::RenderSystemDrawing* p_RenderSystem);
    virtual void Finalize(void);

    virtual void Start(void);
    virtual void End(void);

    void GetMicData(s16* pDest, size_t size);
    void CopyMicData(s16* pDest, size_t size);

    virtual void DrawFrame(void);

private:
    static const int MIC_BUFFER_SIZE   = nn::mic::BUFFER_ALIGNMENT_SIZE;
    static const u8  MIC_GAIN          = 43;
    
    size_t m_SamplingLength;
    u8 m_MicGain;
    bool m_RetryStart;
    NN_PADDING2;

    static char m_MicBuffer[MIC_BUFFER_SIZE];
};

/* NN_SAMPLE_DEMOS_DEMO1_MIC_H_ */
#endif

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
