/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     rtc.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/fnd.h>
#include "rtc.h"

void RtcDemo::DrawFrame(void)
{
    // String data for day of the week
    const char WeekStr[][4] = 
    {
        "SUN",
        "MON",
        "TUE",
        "WED",
        "THU",
        "FRI",
        "SAT"
    };

    mp_RenderSystem->SetColor(1.0f, 1.0f, 1.0f, 1.0f);

    // Gets current time
    nn::fnd::DateTime now = nn::fnd::DateTime::GetNow();

    // Title
    mp_RenderSystem->DrawText(248, 0, "CTR demo1");
    // Display current time
    mp_RenderSystem->DrawText(208, 8, "%04d.%02d.%02d %s", now.GetYear(), now.GetMonth(), now.GetDay(), WeekStr[now.GetWeek()]);
    mp_RenderSystem->DrawText(256, 16, "%02d:%02d:%02d", now.GetHour(), now.GetMinute(), now.GetSecond());
}

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
