﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     snd.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLE_DEMOS_DEMO1_SND_H_
#define NN_SAMPLE_DEMOS_DEMO1_SND_H_

#include "../device.h"

class SndDemo : public Device
{
public:
    SndDemo(){}
    ~SndDemo(){}

    virtual void Initialize(demo::RenderSystemDrawing* p_RenderSystem) { Device::Initialize(p_RenderSystem); }
    void Initialize(demo::RenderSystemDrawing* p_RenderSystem, nn::fnd::ExpHeap* expHeap);
    virtual void Finalize(void);

    virtual void Start(void);
    virtual void End(void);

    virtual void DrawFrame(void);

    void SoundThreadFuncImpl(void);

private:
    nn::os::Thread m_SoundThread;
    nn::fnd::ExpHeap* mp_AppHeap;
    bool m_EndFlag;
    NN_PADDING3;
};

/* NN_SAMPLE_DEMOS_DEMO1_SND_H_ */
#endif

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
