﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     module.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn.h>

#include <nn/fnd.h>
#include <nn/os.h>

extern "C" NN_DLL_EXPORT void Test();
extern "C" NN_DLL_EXPORT void Test4();
extern "C" NN_DLL_IMPORT void Test3();

#define INDENT  "          "

namespace
{
    class TestClass
    {
    public:
        TestClass()
        {
            NN_LOG(INDENT "Module: TestClass (static initializer)\n");
        }
        ~TestClass()
        {
            NN_LOG(INDENT "Module: ~TestClass (static finalizer)\n");
        }
    };

    TestClass s_TestClass;

    void Test2()
    {
        if( nn::os::Tick::GetSystemCurrent() > 0 )
        {
            NN_LOG(INDENT "Module: throw from Test2\n");
            throw new std::exception();
        }
    }
}



NN_DLL_EXPORT void Test()
{
    NN_LOG(INDENT "Module: Test\n");
    try
    {
        Test2();
    }
    catch(std::exception* p)
    {
        NN_LOG(INDENT "Module: exception occured while calling Test2\n");
        delete p;
    }

    if( nn::os::Tick::GetSystemCurrent() > 0 )
    {
        NN_LOG(INDENT "Module: throw from Test\n");
        throw new std::exception();
    }
}

NN_DLL_EXPORT void Test4()
{
    NN_LOG(INDENT "Module: Test4\n");
    Test3();
}



