﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     module.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn.h>

#include <nn/fnd.h>
#include <nn/os.h>
#include <nn/sinit.h>
#include "module.h"
#include "module2.h"

#define INDENT  "          "

namespace
{
    class TestClass
    {
    public:
        TestClass()
        {
            NN_LOG(INDENT "Module: TestClass (static initializer)\n");
        }
        ~TestClass()
        {
            NN_LOG(INDENT "Module: ~TestClass (static finalizer)\n");
        }
    };

    TestClass s_TestClass;
}

void Test()
{
    NN_LOG(INDENT "Module: Test\n");
    NN_LOG(INDENT "Module: Call Module2Func\n");
    Module2Func();
}

void nninitStaticInit()
{
    NN_LOG(INDENT "Module: nninitStaticInit\n");
}

extern "C" NN_DLL_EXPORT void nnroProlog()
{
    NN_LOG(INDENT "Module: nnroProlog\n");
}

extern "C" NN_DLL_EXPORT void nnroEpilog()
{
    NN_LOG(INDENT "Module: nnroEpilog\n");
}

extern "C" NN_DLL_EXPORT void nnroUnresolved()
{
    NN_LOG(INDENT "Module: nnroUnresolved\n");
}

