/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     3DSurround.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLE_DEMOS_SND_3D_SURROUND_H_
#define NN_SAMPLE_DEMOS_SND_3D_SURROUND_H_

#include <nn/snd.h>
#include "SndDemoBase.h"

class SurroundPlayer : public SndDemoBase
{
protected:
    virtual void OnInitialize();
    virtual void OnFinalize();
    virtual void OnUpdate(nn::hid::PadStatus&);
    virtual void OnDraw(demo::RenderSystemDrawing&);
    virtual void SoundThreadFuncImpl();

    void SetMixParam(nn::snd::Voice*);

private:
    static const int SOUND_THREAD_PRIORITY = 2;
    static const size_t SOUND_THREAD_STACK_SIZE = 4096;
    nn::os::Thread m_SoundThread;
    bool m_SoundThreadFlag;
    NN_PADDING3;
    nn::os::CriticalSection m_CriticalSection;

    // 3D surround control arguments
    nn::util::SizedEnum1<nn::snd::OutputMode> m_OutputMode;
    nn::util::SizedEnum1<nn::snd::SurroundSpeakerPosition> m_SpeakerPosition;
    NN_PADDING2;
    f32 m_SurroundDepth;
    f32 m_Pan0;
    f32 m_Pan1;
};

#endif  // NN_SAMPLE_DEMOS_SND_3D_SURROUND_H_
