﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     StreamPlayer.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLE_DEMOS_SND_STREAM_PLAYER_H_
#define NN_SAMPLE_DEMOS_SND_STREAM_PLAYER_H_

#include "SndDemoBase.h"

class StreamPlayer : public SndDemoBase
{
protected:
    virtual void OnInitialize();
    virtual void OnFinalize();
    virtual void OnUpdate(nn::hid::PadStatus&);
    virtual void OnDraw(demo::RenderSystemDrawing&);
    virtual void SoundThreadFuncImpl();

private:
    static const int SOUND_THREAD_PRIORITY = 2;
    static const size_t SOUND_THREAD_STACK_SIZE = 4096;
    nn::os::Thread m_SoundThread;
    bool m_SoundThreadFlag;
    NN_PADDING3;
    nn::os::CriticalSection m_CriticalSection;
};

#endif  // NN_SAMPLE_DEMOS_SND_STREAM_PLAYER_H_
