﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     WaveFileReader.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLE_DEMOS_SND_COMMON_WAVE_FILE_READER_H_
#define NN_SAMPLE_DEMOS_SND_COMMON_WAVE_FILE_READER_H_

#include <nn/fs.h>

class WaveFileReader
{
private:
    nn::fs::FileReader m_Reader;
    s64 m_DataSize;
    s64 m_DataOffset;
    s64 m_ReadPosition;
    s32 m_ChannelCount;
    s32 m_SampleRate;
    s32 m_QuantumBits;
    NN_PADDING4;
private:
    void ReadInfo();
public:
    /* Please see man pages for details 
        
     */
    WaveFileReader();
    /* Please see man pages for details 
        
        
     */
    WaveFileReader(const char* pPathName);
    /* Please see man pages for details 
        
                    
     */
    ~WaveFileReader();
    /* Please see man pages for details 
        
                    
        
     */
    void Initialize(const char* pPathName);
    /* Please see man pages for details 
        
                    
        
     */
    void Finalize();
    /* Please see man pages for details 
        
                    
        
     */
    s64 GetDataSize() const { return m_DataSize; }
    /* Please see man pages for details 
        
                    
        
     */
    s32 GetChannelCount() const { return m_ChannelCount; }
    /* Please see man pages for details 
        
                    
        
     */
    s32 GetSampleRate() const { return m_SampleRate; }
    /* Please see man pages for details 
        
                    
        
     */
    s32 GetQuantumBits() const { return m_QuantumBits; }
    /* Please see man pages for details 
        
        
        
        
     */
    s64 ReadData(void* pData, s64 size);
};

#endif  // NN_SAMPLE_DEMOS_SND_COMMON_WAVE_FILE_READER_H_
