﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     WaveFileWriter.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46611 $
 *---------------------------------------------------------------------------*/

#ifndef NN_SAMPLE_DEMOS_SND_COMMON_WAVE_FILE_WRITER_H_
#define NN_SAMPLE_DEMOS_SND_COMMON_WAVE_FILE_WRITER_H_

#include <nn/fs.h>
#include <nn/hio.h>

class WaveFileWriter
{
private:
    nn::fs::FileWriter m_Writer;
    s64 m_DataSize;
    s32 m_ChannelCount;
    s32 m_SampleRate;
    s32 m_QuantumBits;
    NN_PADDING4;
private:
    void WriteHeader();
public:
    /* Please see man pages for details 
        
     */
    WaveFileWriter();
    /* Please see man pages for details 
        
        
     */
    WaveFileWriter(const char* pPathName);
    /* Please see man pages for details 
        
                    
     */
    ~WaveFileWriter();
    /* Please see man pages for details 
        
                    
        
     */
    void Initialize(const char* pPathName);
    /* Please see man pages for details 
        
                    
        
     */
    void Finalize();
    /* Please see man pages for details 
        
        
     */
    void SetChannelCount(s32 channelCount) { m_ChannelCount = channelCount; }
    /* Please see man pages for details 
        
        
     */
    void SetSampleRate(s32 sampleRate) { m_SampleRate = sampleRate; }
    /* Please see man pages for details 
        
        
     */
    void SetQuantumBits(s32 quantumBits) { m_QuantumBits = quantumBits; }
    /* Please see man pages for details 
        
        
        
     */
    void WriteData(const void* pData, s64 size);
};

#ifdef SND_DEMO_HOST_IO
class HostIoWaveFileWriter
{
private:
    nn::hio::HostFile m_Writer;
    NN_PADDING4;
    s64 m_DataSize;
    s32 m_ChannelCount;
    s32 m_SampleRate;
    s32 m_QuantumBits;
    NN_PADDING4;
private:
    void WriteHeader();
public:
    /* Please see man pages for details 
        
    */
    HostIoWaveFileWriter();
    /* Please see man pages for details 
        
        
     */
    HostIoWaveFileWriter(const char* pPathName);
    /* Please see man pages for details 
        
                    
     */
    ~HostIoWaveFileWriter();
    /* Please see man pages for details 
        
                    
        
     */
    void Initialize(const char* pPathName);
    /* Please see man pages for details 
        
                    
        
     */
    void Finalize();
    /* Please see man pages for details 
        
        
     */
    void SetChannelCount(s32 channelCount) { m_ChannelCount = channelCount; }
    /* Please see man pages for details 
        
        
     */
    void SetSampleRate(s32 sampleRate) { m_SampleRate = sampleRate; }
    /* Please see man pages for details 
        
        
     */
    void SetQuantumBits(s32 quantumBits) { m_QuantumBits = quantumBits; }
    /* Please see man pages for details 
        
        
        
     */
    void WriteData(const void* pData, s64 size);
};
#endif  // SND_DEMO_HOST_IO

#endif  // NN_SAMPLE_DEMOS_SND_COMMON_WAVE_FILE_WRITER_H_
