﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     ubl_Main.cpp

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 46365 $
 *---------------------------------------------------------------------------*/

#include <nn/ubl.h>
#include <nn/applet.h>

extern "C" void nnMain()
{
    // Call only nn::applet::Enable to also allow execution from the HOME Menu
    // HOME Menu transitions, POWER Button presses, and sleep are all unsupported
    nn::applet::Enable();

    static u64 idData[3]={
        0x123456789ABCDEF0LL,0xA1E03F594B8C7D62LL,0xCF72E905B3D614A8LL
    };
    nn::Result result;
    s32 i;

    //Initialization
    result = nn::ubl::Initialize();
    if(result.IsFailure()){
        NN_PANIC("Could not initialize.\n");
    }

    nn::fnd::DateTime dt = nn::fnd::DateTime::GetNow();
    //ID registration
    result = nn::ubl::Entry(idData[0],&dt);
    if(result.IsFailure()){
        NN_PANIC("Could not use entry id.\n");
    }
    result = nn::ubl::Entry(idData[1],&dt);
    if(result.IsFailure()){
        NN_PANIC("Could not use entry id.\n");
    }
    //Get the total number of users
    NN_LOG("Total number of blacklist users = %d.\n",nn::ubl::GetTotalLocalUser());
    //ID check
    for( i = 0 ; i < 3 ; i++ ){
        if(nn::ubl::IsExist(idData[i],0,0) == true){
            NN_LOG("id=%llX found.\n",idData[i]);
        }
        else{
            NN_LOG("id=%llX not found.\n",idData[i]);
        }
    }

    //Quit
    NN_LOG("*** End of demo ***\n");

    nn::ubl::Finalize();
    while(true){}
}
